import java.util.ArrayList;

public class Sudoku{
  public static void main(String[] args) {
    PartialSolution puzzle1 = new PartialSolution();
    
    // http://www.websudoku.com/?level=4&set_id=1477805635
    
     puzzle1 = PartialSolution.fromMatrix( new int[][] { 
       {0,6,2, 3,0,0, 0,0,0}, {5,0,0, 9,7,0, 1,0,0}, {0,0,0, 0,4,0, 0,5,0},
       {0,0,0, 5,0,0, 9,1,0}, {0,4,0, 0,0,0, 0,8,0}, {0,2,1, 0,0,4, 0,0,0},
       {0,5,0, 0,8,0, 0,0,0}, {0,0,7, 0,3,9, 0,0,0}, {0,0,0, 0,0,0, 0,0,0} });
    
    System.out.println("Starting to solve from initial PartialSolution:");
    System.out.println((new PartialSolution(puzzle1)).toString());
    
    long startTime = System.currentTimeMillis();
    
    ArrayList<PartialSolution> sols = puzzle1.findSolution();
    
    long endTime = System.currentTimeMillis() ;
    System.out.println("Time: "+(endTime-startTime));
    System.out.println("Number of PartialSolutions generated: " + puzzle1.getIntermediateSolutions());
    System.out.println("The solutions are:" + sols.size());
  }
}