import junit.framework.TestCase;
import java.util.*;
/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class TestSolution extends TestCase {
  
  /**
   * TODO
   */
  
  //  http://www.websudoku.com/?level=1&set_id=5228442106
  public void testEasy1() {
    int mat[][] =  new int[][] { 
      {0,0,3, 9,0,0, 0,0,2}, {9,2,0, 0,6,0, 0,8,1}, {0,0,5, 8,0,0, 0,3,0},
      {0,0,9, 5,8,1, 0,0,0}, {0,8,6, 4,0,9, 1,7,0}, {0,0,0, 3,7,6, 4,0,0},
      {0,3,0, 0,0,7, 2,0,0}, {5,4,0, 0,9,0, 0,1,3}, {1,0,0, 0,0,4, 8,0,0} };
     checkSolutions(mat, 1);
  }
  
  // http://www.websudoku.com/?level=4&set_id=1477805635
  public void testEvil1() {
    int mat[][] =  new int[][] {
       {0,6,2, 3,0,0, 0,0,0}, {5,0,0, 9,7,0, 1,0,0}, {0,0,0, 0,4,0, 0,5,0},
       {0,0,0, 5,0,0, 9,1,0}, {0,4,0, 0,0,0, 0,8,0}, {0,2,1, 0,0,4, 0,0,0},
       {0,5,0, 0,8,0, 0,0,0}, {0,0,7, 0,3,9, 0,0,2}, {0,0,0, 0,0,1, 8,6,0} };
    checkSolutions(mat, 1);
  }
  
  // multiple solution variation of the testEvi11 test
   public void testEvil2() {
    int mat[][] =  new int[][] {
       {0,6,2, 3,0,0, 0,0,0}, {5,0,0, 9,7,0, 1,0,0}, {0,0,0, 0,4,0, 0,5,0},
       {0,0,0, 5,0,0, 9,1,0}, {0,4,0, 0,0,0, 0,8,0}, {0,2,1, 0,0,4, 0,0,0},
       {0,5,0, 0,8,0, 0,0,0}, {0,0,7, 0,3,9, 0,0,2}, {0,0,0, 0,0,1, 8,0,0} };
    checkSolutions(mat, 8);
  }
  
  public void checkSolutions(int[][] mat, int noSol) {
    PartialSolution p =  PartialSolution.fromMatrix( mat );
     ArrayList<PartialSolution> sols = p.findSolution();
    assertTrue("Incorrect number of solutions "+sols.size(), sols.size()==noSol);
    for(PartialSolution ps : sols) {
      assertTrue(ps.checkSolution(mat));
    }
  }
}
